#include <p18f452.h>
#define clavsort PORTB
#define claventre PORTA

char keyget(void) {
	static char old_key;
	char old_c=clavsort;
	char x=0;
	clavsort = 0b00001110;
	if (claventre==0b11100000) x='A';
	if (claventre==0b11010000) x='0';
	if (claventre==0b10110000) x='B';
	if (claventre==0b01110000) x='C';
	clavsort = 0b00001101;
	if (claventre==0b11100000) x='7';
	if ((claventre&0b00100000)==0) x='8';
	if ((claventre&0b01000000)==0) x='9';
	if ((claventre&0b10000000)==0) x='D';
	clavsort = 0b00001011;
	if ((claventre&0b00010000)==0) x='4';
	if ((claventre&0b00100000)==0) x='5';
	if ((claventre&0b01000000)==0) x='6';
	if ((claventre&0b10000000)==0) x='E';
	clavsort = 0b00000111;
	if ((claventre&0b00010000)==0) x='1';
	if ((claventre&0b00100000)==0) x='2';
	if ((claventre&0b01000000)==0) x='3';
	if ((claventre&0b10000000)==0) x='F';

	clavsort = old_c;
	if (x==old_key)
		return 0;
	old_key = x;
	return x;
}

// exemple d'utilisation
/*
void main (void) 
{
	char c=0;
	TRISB=0b00000000;
	TRISA=0b11111111;
	while(1) { c=keyget(); 
				if (c) 
					{
						Nop();
						Nop();
					}	
			
			}
}
*/
